Panda3D

Loading...
Searching...
No Matches
Public Member Functions | List of all members
NurbsSurfaceResult Class Reference

The result of a NurbsSurfaceEvaluator. More...

`#include "nurbsSurfaceResult.h"`

Inheritance diagram for NurbsSurfaceResult:

## Public Member Functions
| NurbsSurfaceResult (const NurbsBasisVector &u_basis, const NurbsBasisVector &v_basis, const LVecBase4 vecs[], const NurbsVertex *verts, int num_u_vertices, int num_v_vertices)
| The constructor automatically builds up the result as the product of the indicated set of basis matrices and the indicated table of control vertex positions.
PN_stdfloat | eval_extended_point (PN_stdfloat u, PN_stdfloat v, int d)
| Evaluates the surface in n-dimensional space according to the extended vertices associated with the surface in the indicated dimension.
bool | eval_extended_points (PN_stdfloat u, PN_stdfloat v, int d, PN_stdfloat result[], int num_values)
| Simultaneously performs eval_extended_point on a contiguous sequence of dimensions.
bool | eval_normal (PN_stdfloat u, PN_stdfloat v, LVecBase3 &normal)
| Computes the normal to the surface at the indicated point in parametric time.
bool | eval_point (PN_stdfloat u, PN_stdfloat v, LVecBase3 &point)
| Computes the point on the surface corresponding to the indicated value in parametric time.
PN_stdfloat | eval_segment_extended_point (int ui, int vi, PN_stdfloat u, PN_stdfloat v, int d) const
| Evaluates the surface in n-dimensional space according to the extended vertices associated with the surface in the indicated dimension.
void | eval_segment_extended_points (int ui, int vi, PN_stdfloat u, PN_stdfloat v, int d, PN_stdfloat result[], int num_values) const
| Simultaneously performs eval_extended_point on a contiguous sequence of dimensions.
void | eval_segment_normal (int ui, int vi, PN_stdfloat u, PN_stdfloat v, LVecBase3 &normal) const
| As eval_segment_point, but computes the normal to the surface at the indicated point.
void | eval_segment_point (int ui, int vi, PN_stdfloat u, PN_stdfloat v, LVecBase3 &point) const
| Evaluates the point on the surface corresponding to the indicated value in parametric time within the indicated surface segment.
PN_stdfloat | get_end_u () const
| Returns the last legal value of u on the surface.
PN_stdfloat | get_end_v () const
| Returns the last legal value of v on the surface.
int | get_num_u_segments () const
| Returns the number of piecewise continuous segments within the surface in the U direction.
int | get_num_v_segments () const
| Returns the number of piecewise continuous segments within the surface in the V direction.
PN_stdfloat | get_segment_u (int ui, PN_stdfloat u) const
| Accepts a u value in the range [0, 1], and assumed to be relative to the indicated segment (as in eval_segment_point()), and returns the corresponding u value in the entire surface (as in eval_point()).
PN_stdfloat | get_segment_v (int vi, PN_stdfloat v) const
| Accepts a v value in the range [0, 1], and assumed to be relative to the indicated segment (as in eval_segment_point()), and returns the corresponding v value in the entire surface (as in eval_point()).
PN_stdfloat | get_start_u () const
| Returns the first legal value of u on the surface.
PN_stdfloat | get_start_v () const
| Returns the first legal value of v on the surface.
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Additional Inherited Members
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

The result of a NurbsSurfaceEvaluator.

This object represents a surface in a particular coordinate space. It can return the point and/or normal to the surface at any point.

Definition at line 29 of file nurbsSurfaceResult.h.

## Constructor & Destructor Documentation

## ◆ NurbsSurfaceResult()

NurbsSurfaceResult::NurbsSurfaceResult | ( | const NurbsBasisVector & | u_basis,
|  | const NurbsBasisVector & | v_basis,
|  | const LVecBase4 | vecs[],
|  | const NurbsVertex * | verts,
|  | int | num_u_vertices,
|  | int | num_v_vertices )

The constructor automatically builds up the result as the product of the indicated set of basis matrices and the indicated table of control vertex positions.

Definition at line 23 of file nurbsSurfaceResult.cxx.

## ◆ ~NurbsSurfaceResult()

NurbsSurfaceResult::~NurbsSurfaceResult | ( |  | ) |
| inline

Definition at line 17 of file nurbsSurfaceResult.I.

## Member Function Documentation

## ◆ eval_extended_point()

PN_stdfloat NurbsSurfaceResult::eval_extended_point | ( | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | int | d )
| inline

Evaluates the surface in n-dimensional space according to the extended vertices associated with the surface in the indicated dimension.

Definition at line 93 of file nurbsSurfaceResult.I.

References eval_segment_extended_point().

## ◆ eval_extended_points()

bool NurbsSurfaceResult::eval_extended_points | ( | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | int | d,
|  | PN_stdfloat | result[],
|  | int | num_values )
| inline

Simultaneously performs eval_extended_point on a contiguous sequence of dimensions.

The dimensions evaluated are d through (d + num_values - 1); the results are filled into the num_values elements in the indicated result array.

Definition at line 111 of file nurbsSurfaceResult.I.

References eval_segment_extended_points().

## ◆ eval_normal()

bool NurbsSurfaceResult::eval_normal | ( | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | LVecBase3 & | normal )
| inline

Computes the normal to the surface at the indicated point in parametric time.

This normal vector will not necessarily be normalized, and could be zero. See also eval_point().

Definition at line 76 of file nurbsSurfaceResult.I.

References eval_segment_normal().

## ◆ eval_point()

bool NurbsSurfaceResult::eval_point | ( | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | LVecBase3 & | point )
| inline

Computes the point on the surface corresponding to the indicated value in parametric time.

Returns true if the u, v values are valid, false otherwise.

Definition at line 58 of file nurbsSurfaceResult.I.

References eval_segment_point().

## ◆ eval_segment_extended_point()

PN_stdfloat NurbsSurfaceResult::eval_segment_extended_point | ( | int | ui,
|  | int | vi,
|  | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | int | d ) const

Evaluates the surface in n-dimensional space according to the extended vertices associated with the surface in the indicated dimension.

Definition at line 158 of file nurbsSurfaceResult.cxx.

Referenced by eval_extended_point().

## ◆ eval_segment_extended_points()

void NurbsSurfaceResult::eval_segment_extended_points | ( | int | ui,
|  | int | vi,
|  | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | int | d,
|  | PN_stdfloat | result[],
|  | int | num_values ) const

Simultaneously performs eval_extended_point on a contiguous sequence of dimensions.

The dimensions evaluated are d through (d + num_values - 1); the results are filled into the num_values elements in the indicated result array.

Definition at line 201 of file nurbsSurfaceResult.cxx.

Referenced by eval_extended_points().

## ◆ eval_segment_normal()

void NurbsSurfaceResult::eval_segment_normal | ( | int | ui,
|  | int | vi,
|  | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | LVecBase3 & | normal ) const

As eval_segment_point, but computes the normal to the surface at the indicated point.

The normal vector will not necessarily be normalized, and could be zero.

Definition at line 131 of file nurbsSurfaceResult.cxx.

Referenced by eval_normal().

## ◆ eval_segment_point()

void NurbsSurfaceResult::eval_segment_point | ( | int | ui,
|  | int | vi,
|  | PN_stdfloat | u,
|  | PN_stdfloat | v,
|  | LVecBase3 & | point ) const

Evaluates the point on the surface corresponding to the indicated value in parametric time within the indicated surface segment.

u and v should be in the range [0, 1].

The surface is internally represented as a number of connected (or possibly unconnected) piecewise continuous segments. The exact number of segments for a particular surface depends on the knot vector, and is returned by get_num_segments(). Normally, eval_point() is used to evaluate a point along the continuous surface, but when you care more about local continuity, you can use eval_segment_point() to evaluate the points along each segment.

Definition at line 109 of file nurbsSurfaceResult.cxx.

Referenced by eval_point().

## ◆ get_end_u()

PN_stdfloat NurbsSurfaceResult::get_end_u | ( |  | ) | const
| inline

Returns the last legal value of u on the surface.

Definition at line 32 of file nurbsSurfaceResult.I.

## ◆ get_end_v()

PN_stdfloat NurbsSurfaceResult::get_end_v | ( |  | ) | const
| inline

Returns the last legal value of v on the surface.

Definition at line 48 of file nurbsSurfaceResult.I.

## ◆ get_num_u_segments()

int NurbsSurfaceResult::get_num_u_segments | ( |  | ) | const
| inline

Returns the number of piecewise continuous segments within the surface in the U direction.

This number is usually not important unless you plan to call eval_segment_point().

Definition at line 131 of file nurbsSurfaceResult.I.

## ◆ get_num_v_segments()

int NurbsSurfaceResult::get_num_v_segments | ( |  | ) | const
| inline

Returns the number of piecewise continuous segments within the surface in the V direction.

This number is usually not important unless you plan to call eval_segment_point().

Definition at line 141 of file nurbsSurfaceResult.I.

## ◆ get_segment_u()

PN_stdfloat NurbsSurfaceResult::get_segment_u | ( | int | ui,
|  | PN_stdfloat | u ) const
| inline

Accepts a u value in the range [0, 1], and assumed to be relative to the indicated segment (as in eval_segment_point()), and returns the corresponding u value in the entire surface (as in eval_point()).

Definition at line 151 of file nurbsSurfaceResult.I.

## ◆ get_segment_v()

PN_stdfloat NurbsSurfaceResult::get_segment_v | ( | int | vi,
|  | PN_stdfloat | v ) const
| inline

Accepts a v value in the range [0, 1], and assumed to be relative to the indicated segment (as in eval_segment_point()), and returns the corresponding v value in the entire surface (as in eval_point()).

Definition at line 161 of file nurbsSurfaceResult.I.

## ◆ get_start_u()

PN_stdfloat NurbsSurfaceResult::get_start_u | ( |  | ) | const
| inline

Returns the first legal value of u on the surface.

Usually this is 0.0.

Definition at line 24 of file nurbsSurfaceResult.I.

## ◆ get_start_v()

PN_stdfloat NurbsSurfaceResult::get_start_v | ( |  | ) | const
| inline

Returns the first legal value of v on the surface.

Usually this is 0.0.

Definition at line 40 of file nurbsSurfaceResult.I.

The documentation for this class was generated from the following files:

- panda/src/parametrics/nurbsSurfaceResult.h
- panda/src/parametrics/nurbsSurfaceResult.cxx
- panda/src/parametrics/nurbsSurfaceResult.I